import { FetchFunction } from '@pnpm/fetcher-base';
import { FetchPackageToStoreFunction, RequestPackageFunction } from '@pnpm/package-requester';
import { ResolveFunction } from '@pnpm/resolver-base';
import { ImportPackageFunction } from './createImportPackage';
export interface StoreController {
    requestPackage: RequestPackageFunction;
    fetchPackage: FetchPackageToStoreFunction;
    importPackage: ImportPackageFunction;
    close(): Promise<void>;
    updateConnections(prefix: string, opts: {
        addDependencies: string[];
        removeDependencies: string[];
        prune: boolean;
    }): Promise<void>;
    prune(): Promise<void>;
    saveState(): Promise<void>;
    upload(builtPkgLocation: string, opts: {
        pkgId: string;
        engine: string;
    }): Promise<void>;
}
export default function (resolve: ResolveFunction, fetchers: {
    [type: string]: FetchFunction;
}, initOpts: {
    locks?: string;
    lockStaleDuration?: number;
    store: string;
    networkConcurrency?: number;
    packageImportMethod?: 'auto' | 'hardlink' | 'copy' | 'reflink';
}): Promise<StoreController>;
